# *1.2.0*

Eighteenth release of RainbowCake.

## What's new

### Eased requirements for layout inflation in RainbowCakeFragments

Previously, this base Fragment strictly required overriding the `getViewResource` method, and inflated the layout returned from that method in `onCreateView`, which was also mandatory to call if overridden.

This was inconvenient when using View Binding or Date Binding, so now:

- `getViewResource` is no longer abstract, instead it returns `0` by default. If you don't override `getViewResource`, you _must_ override `onCreateView`.
- Overriding `onCreateView` no longer requires a call to the super method.

### Introduced the `@InternalRainbowCakeApi` opt-in annotation

This annotation is only for internal use between RainbowCake's modules. Previous visibility hacks have been replaced with this new annotation. You should generally avoid opting into its usage, as it's not guaranteed public API.

The `coroutineScope` used by `RainbowCakeViewModel` is now exposed as `@InternalRainbowCakeApi` for extensions that need access to this scope.

### Small changes

- Removed the `Application` receiver of the `rainbowCake` configuration function, to make it easier to call

### Dependency updates

- Kotlin 1.4.10
- Android Gradle Plugin 4.1.0
- Dagger 2.29.1
- Gradle wrapper 6.7
- AndroidX libraries to latest versions
